From VFP Require Import ClightGeneration.
From Coq Require Import String List ZArith.
From compcert Require Import Coqlib Integers Floats AST Ctypes Cop Clight Clightdefs.
Import Clightdefs.ClightNotations.
Local Open Scope Z_scope.
Local Open Scope string_scope.
Local Open Scope clight_scope.

Module Info.
  Definition version := "3.12".
  Definition build_number := "".
  Definition build_tag := "".
  Definition build_branch := "".
  Definition arch := "x86".
  Definition model := "64".
  Definition abi := "standard".
  Definition bitsize := 64.
  Definition big_endian := false.
  Definition source_file := "common-c-code/common_flight_plan.c".
  Definition normalized := false.
End Info.

Definition _NextBlock : ident := #"NextBlock".
Definition _NextStage : ident := #"NextStage".
Definition _Return : ident := #"Return".
Definition ___builtin_ais_annot : ident := #"__builtin_ais_annot".
Definition ___builtin_annot : ident := #"__builtin_annot".
Definition ___builtin_annot_intval : ident := #"__builtin_annot_intval".
Definition ___builtin_bswap : ident := #"__builtin_bswap".
Definition ___builtin_bswap16 : ident := #"__builtin_bswap16".
Definition ___builtin_bswap32 : ident := #"__builtin_bswap32".
Definition ___builtin_bswap64 : ident := #"__builtin_bswap64".
Definition ___builtin_clz : ident := #"__builtin_clz".
Definition ___builtin_clzl : ident := #"__builtin_clzl".
Definition ___builtin_clzll : ident := #"__builtin_clzll".
Definition ___builtin_ctz : ident := #"__builtin_ctz".
Definition ___builtin_ctzl : ident := #"__builtin_ctzl".
Definition ___builtin_ctzll : ident := #"__builtin_ctzll".
Definition ___builtin_debug : ident := #"__builtin_debug".
Definition ___builtin_expect : ident := #"__builtin_expect".
Definition ___builtin_fabs : ident := #"__builtin_fabs".
Definition ___builtin_fabsf : ident := #"__builtin_fabsf".
Definition ___builtin_fmadd : ident := #"__builtin_fmadd".
Definition ___builtin_fmax : ident := #"__builtin_fmax".
Definition ___builtin_fmin : ident := #"__builtin_fmin".
Definition ___builtin_fmsub : ident := #"__builtin_fmsub".
Definition ___builtin_fnmadd : ident := #"__builtin_fnmadd".
Definition ___builtin_fnmsub : ident := #"__builtin_fnmsub".
Definition ___builtin_fsqrt : ident := #"__builtin_fsqrt".
Definition ___builtin_membar : ident := #"__builtin_membar".
Definition ___builtin_memcpy_aligned : ident := #"__builtin_memcpy_aligned".
Definition ___builtin_read16_reversed : ident := #"__builtin_read16_reversed".
Definition ___builtin_read32_reversed : ident := #"__builtin_read32_reversed".
Definition ___builtin_sel : ident := #"__builtin_sel".
Definition ___builtin_sqrt : ident := #"__builtin_sqrt".
Definition ___builtin_unreachable : ident := #"__builtin_unreachable".
Definition ___builtin_va_arg : ident := #"__builtin_va_arg".
Definition ___builtin_va_copy : ident := #"__builtin_va_copy".
Definition ___builtin_va_end : ident := #"__builtin_va_end".
Definition ___builtin_va_start : ident := #"__builtin_va_start".
Definition ___builtin_write16_reversed : ident := #"__builtin_write16_reversed".
Definition ___builtin_write32_reversed : ident := #"__builtin_write32_reversed".
Definition ___compcert_i64_dtos : ident := #"__compcert_i64_dtos".
Definition ___compcert_i64_dtou : ident := #"__compcert_i64_dtou".
Definition ___compcert_i64_sar : ident := #"__compcert_i64_sar".
Definition ___compcert_i64_sdiv : ident := #"__compcert_i64_sdiv".
Definition ___compcert_i64_shl : ident := #"__compcert_i64_shl".
Definition ___compcert_i64_shr : ident := #"__compcert_i64_shr".
Definition ___compcert_i64_smod : ident := #"__compcert_i64_smod".
Definition ___compcert_i64_smulh : ident := #"__compcert_i64_smulh".
Definition ___compcert_i64_stod : ident := #"__compcert_i64_stod".
Definition ___compcert_i64_stof : ident := #"__compcert_i64_stof".
Definition ___compcert_i64_udiv : ident := #"__compcert_i64_udiv".
Definition ___compcert_i64_umod : ident := #"__compcert_i64_umod".
Definition ___compcert_i64_umulh : ident := #"__compcert_i64_umulh".
Definition ___compcert_i64_utod : ident := #"__compcert_i64_utod".
Definition ___compcert_i64_utof : ident := #"__compcert_i64_utof".
Definition ___compcert_va_composite : ident := #"__compcert_va_composite".
Definition ___compcert_va_float64 : ident := #"__compcert_va_float64".
Definition ___compcert_va_int32 : ident := #"__compcert_va_int32".
Definition ___compcert_va_int64 : ident := #"__compcert_va_int64".
Definition _b : ident := #"b".
Definition _block_time : ident := #"block_time".
Definition _forbidden_deroute : ident := #"forbidden_deroute".
Definition _get_last_block : ident := #"get_last_block".
Definition _get_last_stage : ident := #"get_last_stage".
Definition _get_nav_block : ident := #"get_nav_block".
Definition _get_nav_stage : ident := #"get_nav_stage".
Definition _init_function : ident := #"init_function".
Definition _last_block : ident := #"last_block".
Definition _last_stage : ident := #"last_stage".
Definition _main : ident := #"main".
Definition _nav_block : ident := #"nav_block".
Definition _nav_goto_block : ident := #"nav_goto_block".
Definition _nav_init_block : ident := #"nav_init_block".
Definition _nav_init_stage : ident := ##"nav_init_stage".
Definition _nav_stage : ident := #"nav_stage".
Definition _nb_blocks : ident := #"nb_blocks".
Definition _on_enter_block : ident := #"on_enter_block".
Definition _on_exit_block : ident := #"on_exit_block".
Definition _private_last_block : ident := #"private_last_block".
Definition _private_last_stage : ident := #"private_last_stage".
Definition _private_nav_block : ident := #"private_nav_block".
Definition _private_nav_stage : ident := #"private_nav_stage".
Definition _s : ident := #"s".
Definition _set_nav_block : ident := #"set_nav_block".
Definition _set_nav_stage : ident := #"set_nav_stage".
Definition _stage_time : ident := #"stage_time".
Definition _x : ident := #"x".
Definition _t'1 : ident := #"t'1".

Definition v_nb_blocks := {|
  gvar_info := tuchar;
  gvar_init := nil;
  gvar_readonly := true;
  gvar_volatile := false
|}.

Definition v_stage_time := {|
  gvar_info := tushort;
  gvar_init := (Init_space 2 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_block_time := {|
  gvar_info := tushort;
  gvar_init := (Init_space 2 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_nav_stage := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_nav_block := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_last_block := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_last_stage := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_private_nav_stage := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_private_nav_block := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_private_last_block := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition v_private_last_stage := {|
  gvar_info := tuchar;
  gvar_init := (Init_space 1 :: nil);
  gvar_readonly := false;
  gvar_volatile := false
|}.

Definition f_init_function := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Ssequence
  (Sassign (Evar _private_nav_stage tuchar) (Econst_int (Int.repr 0) tint))
  (Ssequence
    (Sassign (Evar _nav_stage tuchar) (Econst_int (Int.repr 0) tint))
    (Ssequence
      (Sassign (Evar _private_nav_block tuchar)
        (Econst_int (Int.repr 0) tint))
      (Ssequence
        (Sassign (Evar _nav_block tuchar) (Econst_int (Int.repr 0) tint))
        (Ssequence
          (Sassign (Evar _private_last_stage tuchar)
            (Econst_int (Int.repr 0) tint))
          (Ssequence
            (Sassign (Evar _last_stage tuchar)
              (Econst_int (Int.repr 0) tint))
            (Ssequence
              (Sassign (Evar _private_last_block tuchar)
                (Econst_int (Int.repr 0) tint))
              (Sassign (Evar _last_block tuchar)
                (Econst_int (Int.repr 0) tint)))))))))
|}.

Definition f_get_nav_block := {|
  fn_return := tuchar;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Sreturn (Some (Evar _private_nav_block tuchar)))
|}.

Definition f_get_nav_stage := {|
  fn_return := tuchar;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Sreturn (Some (Evar _private_nav_stage tuchar)))
|}.

Definition f_get_last_block := {|
  fn_return := tuchar;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Sreturn (Some (Evar _private_last_block tuchar)))
|}.

Definition f_get_last_stage := {|
  fn_return := tuchar;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Sreturn (Some (Evar _private_last_stage tuchar)))
|}.

Definition f_set_nav_block := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := ((_b, tuchar) :: nil);
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Ssequence
  (Sifthenelse (Ebinop Oge (Etempvar _b tuchar) (Evar _nb_blocks tuchar)
                 tint)
    (Sassign (Evar _private_nav_block tuchar)
      (Ebinop Osub (Evar _nb_blocks tuchar) (Econst_int (Int.repr 1) tint)
        tint))
    (Sassign (Evar _private_nav_block tuchar) (Etempvar _b tuchar)))
  (Sassign (Evar _nav_block tuchar) (Evar _private_nav_block tuchar)))
|}.

Definition f_set_nav_stage := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := ((_s, tuchar) :: nil);
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Ssequence
  (Sassign (Evar _private_nav_stage tuchar) (Etempvar _s tuchar))
  (Sassign (Evar _nav_stage tuchar) (Etempvar _s tuchar)))
|}.

Definition f_NextBlock := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Sifthenelse (Ebinop Olt (Evar _private_nav_block tuchar)
               (Ebinop Osub (Evar _nb_blocks tuchar)
                 (Econst_int (Int.repr 1) tint) tint) tint)
  (Scall None
    (Evar _nav_goto_block (Tfunction (Tcons tuchar Tnil) tvoid cc_default))
    ((Ebinop Oadd (Evar _private_nav_block tuchar)
       (Econst_int (Int.repr 1) tint) tint) :: nil))
  (Scall None
    (Evar _nav_goto_block (Tfunction (Tcons tuchar Tnil) tvoid cc_default))
    ((Evar _private_nav_block tuchar) :: nil)))
|}.

Definition f_NextStage := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Ssequence
  (Sassign (Evar _private_nav_stage tuchar)
    (Ebinop Oadd (Evar _private_nav_stage tuchar)
      (Econst_int (Int.repr 1) tint) tint))
  (Ssequence
    (Sassign (Evar _nav_stage tuchar) (Evar _private_nav_stage tuchar))
    (Scall None (Evar _nav_init_stage (Tfunction Tnil tvoid cc_default)) nil)))
|}.

Definition f_Return := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := ((_x, tuchar) :: nil);
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Ssequence
  (Scall None
    (Evar _on_exit_block (Tfunction (Tcons tuchar Tnil) tvoid cc_default))
    ((Evar _private_nav_block tuchar) :: nil))
  (Ssequence
    (Sassign (Evar _private_nav_block tuchar)
      (Evar _private_last_block tuchar))
    (Ssequence
      (Sassign (Evar _nav_block tuchar) (Evar _private_nav_block tuchar))
      (Ssequence
        (Sifthenelse (Ebinop Oeq (Etempvar _x tuchar)
                       (Econst_int (Int.repr 1) tint) tint)
          (Sassign (Evar _private_nav_stage tuchar)
            (Econst_int (Int.repr 0) tint))
          (Sassign (Evar _private_nav_stage tuchar)
            (Evar _private_last_stage tuchar)))
        (Ssequence
          (Sassign (Evar _nav_stage tuchar) (Evar _private_nav_stage tuchar))
          (Ssequence
            (Sassign (Evar _block_time tushort)
              (Econst_int (Int.repr 0) tint))
            (Ssequence
              (Scall None
                (Evar _nav_init_stage (Tfunction Tnil tvoid cc_default)) nil)
              (Scall None
                (Evar _on_enter_block (Tfunction (Tcons tuchar Tnil) tvoid
                                        cc_default))
                ((Evar _private_nav_block tuchar) :: nil)))))))))
|}.

Definition f_nav_init_block := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := nil;
  fn_vars := nil;
  fn_temps := nil;
  fn_body :=
(Ssequence
  (Sifthenelse (Ebinop Oge (Evar _private_nav_block tuchar)
                 (Evar _nb_blocks tuchar) tint)
    (Ssequence
      (Sassign (Evar _private_nav_block tuchar)
        (Ebinop Osub (Evar _nb_blocks tuchar) (Econst_int (Int.repr 1) tint)
          tint))
      (Sassign (Evar _nav_block tuchar) (Evar _private_nav_block tuchar)))
    Sskip)
  (Ssequence
    (Sassign (Evar _private_nav_stage tuchar) (Econst_int (Int.repr 0) tint))
    (Ssequence
      (Sassign (Evar _nav_stage tuchar) (Evar _private_nav_stage tuchar))
      (Ssequence
        (Sassign (Evar _block_time tushort) (Econst_int (Int.repr 0) tint))
        (Ssequence
          (Scall None
            (Evar _nav_init_stage (Tfunction Tnil tvoid cc_default)) nil)
          (Scall None
            (Evar _on_enter_block (Tfunction (Tcons tuchar Tnil) tvoid
                                    cc_default))
            ((Evar _private_nav_block tuchar) :: nil)))))))
|}.

Definition f_nav_goto_block := {|
  fn_return := tvoid;
  fn_callconv := cc_default;
  fn_params := ((_b, tuchar) :: nil);
  fn_vars := nil;
  fn_temps := ((_t'1, tbool) :: nil);
  fn_body :=
(Ssequence
  (Ssequence
    (Scall (Some _t'1)
      (Evar _forbidden_deroute (Tfunction (Tcons tuchar (Tcons tuchar Tnil))
                                 tbool cc_default))
      ((Evar _private_nav_block tuchar) :: (Etempvar _b tuchar) :: nil))
    (Sifthenelse (Etempvar _t'1 tbool) (Sreturn None) Sskip))
  (Ssequence
    (Sifthenelse (Ebinop One (Etempvar _b tuchar)
                   (Evar _private_nav_block tuchar) tint)
      (Ssequence
        (Sassign (Evar _private_last_block tuchar)
          (Evar _private_nav_block tuchar))
        (Ssequence
          (Sassign (Evar _last_block tuchar)
            (Evar _private_last_block tuchar))
          (Ssequence
            (Sassign (Evar _private_last_stage tuchar)
              (Evar _private_nav_stage tuchar))
            (Sassign (Evar _last_stage tuchar)
              (Evar _private_last_stage tuchar)))))
      Sskip)
    (Ssequence
      (Scall None
        (Evar _on_exit_block (Tfunction (Tcons tuchar Tnil) tvoid cc_default))
        ((Evar _private_nav_block tuchar) :: nil))
      (Ssequence
        (Sassign (Evar _private_nav_block tuchar) (Etempvar _b tuchar))
        (Ssequence
          (Sassign (Evar _nav_block tuchar) (Evar _private_nav_block tuchar))
          (Scall None
            (Evar _nav_init_block (Tfunction Tnil tvoid cc_default)) nil))))))
|}.

Definition composites : list composite_definition :=
nil.

Definition global_definitions : list (ident * globdef fundef type) :=
((___compcert_va_int32,
   Gfun(External (EF_runtime "__compcert_va_int32"
                   (mksignature (AST.Tlong :: nil) AST.Tint cc_default))
     (Tcons (tptr tvoid) Tnil) tuint cc_default)) ::
 (___compcert_va_int64,
   Gfun(External (EF_runtime "__compcert_va_int64"
                   (mksignature (AST.Tlong :: nil) AST.Tlong cc_default))
     (Tcons (tptr tvoid) Tnil) tulong cc_default)) ::
 (___compcert_va_float64,
   Gfun(External (EF_runtime "__compcert_va_float64"
                   (mksignature (AST.Tlong :: nil) AST.Tfloat cc_default))
     (Tcons (tptr tvoid) Tnil) tdouble cc_default)) ::
 (___compcert_va_composite,
   Gfun(External (EF_runtime "__compcert_va_composite"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons (tptr tvoid) (Tcons tulong Tnil))
     (tptr tvoid) cc_default)) ::
 (___compcert_i64_dtos,
   Gfun(External (EF_runtime "__compcert_i64_dtos"
                   (mksignature (AST.Tfloat :: nil) AST.Tlong cc_default))
     (Tcons tdouble Tnil) tlong cc_default)) ::
 (___compcert_i64_dtou,
   Gfun(External (EF_runtime "__compcert_i64_dtou"
                   (mksignature (AST.Tfloat :: nil) AST.Tlong cc_default))
     (Tcons tdouble Tnil) tulong cc_default)) ::
 (___compcert_i64_stod,
   Gfun(External (EF_runtime "__compcert_i64_stod"
                   (mksignature (AST.Tlong :: nil) AST.Tfloat cc_default))
     (Tcons tlong Tnil) tdouble cc_default)) ::
 (___compcert_i64_utod,
   Gfun(External (EF_runtime "__compcert_i64_utod"
                   (mksignature (AST.Tlong :: nil) AST.Tfloat cc_default))
     (Tcons tulong Tnil) tdouble cc_default)) ::
 (___compcert_i64_stof,
   Gfun(External (EF_runtime "__compcert_i64_stof"
                   (mksignature (AST.Tlong :: nil) AST.Tsingle cc_default))
     (Tcons tlong Tnil) tfloat cc_default)) ::
 (___compcert_i64_utof,
   Gfun(External (EF_runtime "__compcert_i64_utof"
                   (mksignature (AST.Tlong :: nil) AST.Tsingle cc_default))
     (Tcons tulong Tnil) tfloat cc_default)) ::
 (___compcert_i64_sdiv,
   Gfun(External (EF_runtime "__compcert_i64_sdiv"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons tlong (Tcons tlong Tnil)) tlong
     cc_default)) ::
 (___compcert_i64_udiv,
   Gfun(External (EF_runtime "__compcert_i64_udiv"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons tulong (Tcons tulong Tnil)) tulong
     cc_default)) ::
 (___compcert_i64_smod,
   Gfun(External (EF_runtime "__compcert_i64_smod"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons tlong (Tcons tlong Tnil)) tlong
     cc_default)) ::
 (___compcert_i64_umod,
   Gfun(External (EF_runtime "__compcert_i64_umod"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons tulong (Tcons tulong Tnil)) tulong
     cc_default)) ::
 (___compcert_i64_shl,
   Gfun(External (EF_runtime "__compcert_i64_shl"
                   (mksignature (AST.Tlong :: AST.Tint :: nil) AST.Tlong
                     cc_default)) (Tcons tlong (Tcons tint Tnil)) tlong
     cc_default)) ::
 (___compcert_i64_shr,
   Gfun(External (EF_runtime "__compcert_i64_shr"
                   (mksignature (AST.Tlong :: AST.Tint :: nil) AST.Tlong
                     cc_default)) (Tcons tulong (Tcons tint Tnil)) tulong
     cc_default)) ::
 (___compcert_i64_sar,
   Gfun(External (EF_runtime "__compcert_i64_sar"
                   (mksignature (AST.Tlong :: AST.Tint :: nil) AST.Tlong
                     cc_default)) (Tcons tlong (Tcons tint Tnil)) tlong
     cc_default)) ::
 (___compcert_i64_smulh,
   Gfun(External (EF_runtime "__compcert_i64_smulh"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons tlong (Tcons tlong Tnil)) tlong
     cc_default)) ::
 (___compcert_i64_umulh,
   Gfun(External (EF_runtime "__compcert_i64_umulh"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons tulong (Tcons tulong Tnil)) tulong
     cc_default)) ::
 (___builtin_ais_annot,
   Gfun(External (EF_builtin "__builtin_ais_annot"
                   (mksignature (AST.Tlong :: nil) AST.Tvoid
                     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|}))
     (Tcons (tptr tschar) Tnil) tvoid
     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|})) ::
 (___builtin_bswap64,
   Gfun(External (EF_builtin "__builtin_bswap64"
                   (mksignature (AST.Tlong :: nil) AST.Tlong cc_default))
     (Tcons tulong Tnil) tulong cc_default)) ::
 (___builtin_bswap,
   Gfun(External (EF_builtin "__builtin_bswap"
                   (mksignature (AST.Tint :: nil) AST.Tint cc_default))
     (Tcons tuint Tnil) tuint cc_default)) ::
 (___builtin_bswap32,
   Gfun(External (EF_builtin "__builtin_bswap32"
                   (mksignature (AST.Tint :: nil) AST.Tint cc_default))
     (Tcons tuint Tnil) tuint cc_default)) ::
 (___builtin_bswap16,
   Gfun(External (EF_builtin "__builtin_bswap16"
                   (mksignature (AST.Tint :: nil) AST.Tint16unsigned
                     cc_default)) (Tcons tushort Tnil) tushort cc_default)) ::
 (___builtin_clz,
   Gfun(External (EF_builtin "__builtin_clz"
                   (mksignature (AST.Tint :: nil) AST.Tint cc_default))
     (Tcons tuint Tnil) tint cc_default)) ::
 (___builtin_clzl,
   Gfun(External (EF_builtin "__builtin_clzl"
                   (mksignature (AST.Tlong :: nil) AST.Tint cc_default))
     (Tcons tulong Tnil) tint cc_default)) ::
 (___builtin_clzll,
   Gfun(External (EF_builtin "__builtin_clzll"
                   (mksignature (AST.Tlong :: nil) AST.Tint cc_default))
     (Tcons tulong Tnil) tint cc_default)) ::
 (___builtin_ctz,
   Gfun(External (EF_builtin "__builtin_ctz"
                   (mksignature (AST.Tint :: nil) AST.Tint cc_default))
     (Tcons tuint Tnil) tint cc_default)) ::
 (___builtin_ctzl,
   Gfun(External (EF_builtin "__builtin_ctzl"
                   (mksignature (AST.Tlong :: nil) AST.Tint cc_default))
     (Tcons tulong Tnil) tint cc_default)) ::
 (___builtin_ctzll,
   Gfun(External (EF_builtin "__builtin_ctzll"
                   (mksignature (AST.Tlong :: nil) AST.Tint cc_default))
     (Tcons tulong Tnil) tint cc_default)) ::
 (___builtin_fabs,
   Gfun(External (EF_builtin "__builtin_fabs"
                   (mksignature (AST.Tfloat :: nil) AST.Tfloat cc_default))
     (Tcons tdouble Tnil) tdouble cc_default)) ::
 (___builtin_fabsf,
   Gfun(External (EF_builtin "__builtin_fabsf"
                   (mksignature (AST.Tsingle :: nil) AST.Tsingle cc_default))
     (Tcons tfloat Tnil) tfloat cc_default)) ::
 (___builtin_fsqrt,
   Gfun(External (EF_builtin "__builtin_fsqrt"
                   (mksignature (AST.Tfloat :: nil) AST.Tfloat cc_default))
     (Tcons tdouble Tnil) tdouble cc_default)) ::
 (___builtin_sqrt,
   Gfun(External (EF_builtin "__builtin_sqrt"
                   (mksignature (AST.Tfloat :: nil) AST.Tfloat cc_default))
     (Tcons tdouble Tnil) tdouble cc_default)) ::
 (___builtin_memcpy_aligned,
   Gfun(External (EF_builtin "__builtin_memcpy_aligned"
                   (mksignature
                     (AST.Tlong :: AST.Tlong :: AST.Tlong :: AST.Tlong ::
                      nil) AST.Tvoid cc_default))
     (Tcons (tptr tvoid)
       (Tcons (tptr tvoid) (Tcons tulong (Tcons tulong Tnil)))) tvoid
     cc_default)) ::
 (___builtin_sel,
   Gfun(External (EF_builtin "__builtin_sel"
                   (mksignature (AST.Tint :: nil) AST.Tvoid
                     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|}))
     (Tcons tbool Tnil) tvoid
     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|})) ::
 (___builtin_annot,
   Gfun(External (EF_builtin "__builtin_annot"
                   (mksignature (AST.Tlong :: nil) AST.Tvoid
                     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|}))
     (Tcons (tptr tschar) Tnil) tvoid
     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|})) ::
 (___builtin_annot_intval,
   Gfun(External (EF_builtin "__builtin_annot_intval"
                   (mksignature (AST.Tlong :: AST.Tint :: nil) AST.Tint
                     cc_default)) (Tcons (tptr tschar) (Tcons tint Tnil))
     tint cc_default)) ::
 (___builtin_membar,
   Gfun(External (EF_builtin "__builtin_membar"
                   (mksignature nil AST.Tvoid cc_default)) Tnil tvoid
     cc_default)) ::
 (___builtin_va_start,
   Gfun(External (EF_builtin "__builtin_va_start"
                   (mksignature (AST.Tlong :: nil) AST.Tvoid cc_default))
     (Tcons (tptr tvoid) Tnil) tvoid cc_default)) ::
 (___builtin_va_arg,
   Gfun(External (EF_builtin "__builtin_va_arg"
                   (mksignature (AST.Tlong :: AST.Tint :: nil) AST.Tvoid
                     cc_default)) (Tcons (tptr tvoid) (Tcons tuint Tnil))
     tvoid cc_default)) ::
 (___builtin_va_copy,
   Gfun(External (EF_builtin "__builtin_va_copy"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tvoid
                     cc_default))
     (Tcons (tptr tvoid) (Tcons (tptr tvoid) Tnil)) tvoid cc_default)) ::
 (___builtin_va_end,
   Gfun(External (EF_builtin "__builtin_va_end"
                   (mksignature (AST.Tlong :: nil) AST.Tvoid cc_default))
     (Tcons (tptr tvoid) Tnil) tvoid cc_default)) ::
 (___builtin_unreachable,
   Gfun(External (EF_builtin "__builtin_unreachable"
                   (mksignature nil AST.Tvoid cc_default)) Tnil tvoid
     cc_default)) ::
 (___builtin_expect,
   Gfun(External (EF_builtin "__builtin_expect"
                   (mksignature (AST.Tlong :: AST.Tlong :: nil) AST.Tlong
                     cc_default)) (Tcons tlong (Tcons tlong Tnil)) tlong
     cc_default)) ::
 (___builtin_fmax,
   Gfun(External (EF_builtin "__builtin_fmax"
                   (mksignature (AST.Tfloat :: AST.Tfloat :: nil) AST.Tfloat
                     cc_default)) (Tcons tdouble (Tcons tdouble Tnil))
     tdouble cc_default)) ::
 (___builtin_fmin,
   Gfun(External (EF_builtin "__builtin_fmin"
                   (mksignature (AST.Tfloat :: AST.Tfloat :: nil) AST.Tfloat
                     cc_default)) (Tcons tdouble (Tcons tdouble Tnil))
     tdouble cc_default)) ::
 (___builtin_fmadd,
   Gfun(External (EF_builtin "__builtin_fmadd"
                   (mksignature
                     (AST.Tfloat :: AST.Tfloat :: AST.Tfloat :: nil)
                     AST.Tfloat cc_default))
     (Tcons tdouble (Tcons tdouble (Tcons tdouble Tnil))) tdouble
     cc_default)) ::
 (___builtin_fmsub,
   Gfun(External (EF_builtin "__builtin_fmsub"
                   (mksignature
                     (AST.Tfloat :: AST.Tfloat :: AST.Tfloat :: nil)
                     AST.Tfloat cc_default))
     (Tcons tdouble (Tcons tdouble (Tcons tdouble Tnil))) tdouble
     cc_default)) ::
 (___builtin_fnmadd,
   Gfun(External (EF_builtin "__builtin_fnmadd"
                   (mksignature
                     (AST.Tfloat :: AST.Tfloat :: AST.Tfloat :: nil)
                     AST.Tfloat cc_default))
     (Tcons tdouble (Tcons tdouble (Tcons tdouble Tnil))) tdouble
     cc_default)) ::
 (___builtin_fnmsub,
   Gfun(External (EF_builtin "__builtin_fnmsub"
                   (mksignature
                     (AST.Tfloat :: AST.Tfloat :: AST.Tfloat :: nil)
                     AST.Tfloat cc_default))
     (Tcons tdouble (Tcons tdouble (Tcons tdouble Tnil))) tdouble
     cc_default)) ::
 (___builtin_read16_reversed,
   Gfun(External (EF_builtin "__builtin_read16_reversed"
                   (mksignature (AST.Tlong :: nil) AST.Tint16unsigned
                     cc_default)) (Tcons (tptr tushort) Tnil) tushort
     cc_default)) ::
 (___builtin_read32_reversed,
   Gfun(External (EF_builtin "__builtin_read32_reversed"
                   (mksignature (AST.Tlong :: nil) AST.Tint cc_default))
     (Tcons (tptr tuint) Tnil) tuint cc_default)) ::
 (___builtin_write16_reversed,
   Gfun(External (EF_builtin "__builtin_write16_reversed"
                   (mksignature (AST.Tlong :: AST.Tint :: nil) AST.Tvoid
                     cc_default)) (Tcons (tptr tushort) (Tcons tushort Tnil))
     tvoid cc_default)) ::
 (___builtin_write32_reversed,
   Gfun(External (EF_builtin "__builtin_write32_reversed"
                   (mksignature (AST.Tlong :: AST.Tint :: nil) AST.Tvoid
                     cc_default)) (Tcons (tptr tuint) (Tcons tuint Tnil))
     tvoid cc_default)) ::
 (___builtin_debug,
   Gfun(External (EF_external "__builtin_debug"
                   (mksignature (AST.Tint :: nil) AST.Tvoid
                     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|}))
     (Tcons tint Tnil) tvoid
     {|cc_vararg:=(Some 1); cc_unproto:=false; cc_structret:=false|})) ::
 (_nav_init_stage,
   Gfun(External (EF_external "nav_init_stage"
                   (mksignature nil AST.Tvoid cc_default)) Tnil tvoid
     cc_default)) ::
 (_on_enter_block,
   Gfun(External (EF_external "on_enter_block"
                   (mksignature (AST.Tint :: nil) AST.Tvoid cc_default))
     (Tcons tuchar Tnil) tvoid cc_default)) ::
 (_on_exit_block,
   Gfun(External (EF_external "on_exit_block"
                   (mksignature (AST.Tint :: nil) AST.Tvoid cc_default))
     (Tcons tuchar Tnil) tvoid cc_default)) ::
 (_forbidden_deroute,
   Gfun(External (EF_external "forbidden_deroute"
                   (mksignature (AST.Tint :: AST.Tint :: nil)
                     AST.Tint8unsigned cc_default))
     (Tcons tuchar (Tcons tuchar Tnil)) tbool cc_default)) ::
 (_nb_blocks, Gvar v_nb_blocks) :: (_stage_time, Gvar v_stage_time) ::
 (_block_time, Gvar v_block_time) :: (_nav_stage, Gvar v_nav_stage) ::
 (_nav_block, Gvar v_nav_block) :: (_last_block, Gvar v_last_block) ::
 (_last_stage, Gvar v_last_stage) ::
 (_private_nav_stage, Gvar v_private_nav_stage) ::
 (_private_nav_block, Gvar v_private_nav_block) ::
 (_private_last_block, Gvar v_private_last_block) ::
 (_private_last_stage, Gvar v_private_last_stage) ::
 (_init_function, Gfun(Internal f_init_function)) ::
 (_get_nav_block, Gfun(Internal f_get_nav_block)) ::
 (_get_nav_stage, Gfun(Internal f_get_nav_stage)) ::
 (_get_last_block, Gfun(Internal f_get_last_block)) ::
 (_get_last_stage, Gfun(Internal f_get_last_stage)) ::
 (_set_nav_block, Gfun(Internal f_set_nav_block)) ::
 (_set_nav_stage, Gfun(Internal f_set_nav_stage)) ::
 (_NextBlock, Gfun(Internal f_NextBlock)) ::
 (_NextStage, Gfun(Internal f_NextStage)) ::
 (_Return, Gfun(Internal f_Return)) ::
 (_nav_init_block, Gfun(Internal f_nav_init_block)) ::
 (_nav_goto_block, Gfun(Internal f_nav_goto_block)) :: nil).

Definition public_idents : list ident :=
(_nav_goto_block :: _nav_init_block :: _Return :: _NextStage :: _NextBlock ::
 _set_nav_stage :: _set_nav_block :: _get_last_stage :: _get_last_block ::
 _get_nav_stage :: _get_nav_block :: _init_function :: _last_stage ::
 _last_block :: _nav_block :: _nav_stage :: _block_time :: _stage_time ::
 _nb_blocks :: _forbidden_deroute :: _on_exit_block :: _on_enter_block ::
 _nav_init_stage :: ___builtin_debug :: ___builtin_write32_reversed ::
 ___builtin_write16_reversed :: ___builtin_read32_reversed ::
 ___builtin_read16_reversed :: ___builtin_fnmsub :: ___builtin_fnmadd ::
 ___builtin_fmsub :: ___builtin_fmadd :: ___builtin_fmin ::
 ___builtin_fmax :: ___builtin_expect :: ___builtin_unreachable ::
 ___builtin_va_end :: ___builtin_va_copy :: ___builtin_va_arg ::
 ___builtin_va_start :: ___builtin_membar :: ___builtin_annot_intval ::
 ___builtin_annot :: ___builtin_sel :: ___builtin_memcpy_aligned ::
 ___builtin_sqrt :: ___builtin_fsqrt :: ___builtin_fabsf ::
 ___builtin_fabs :: ___builtin_ctzll :: ___builtin_ctzl :: ___builtin_ctz ::
 ___builtin_clzll :: ___builtin_clzl :: ___builtin_clz ::
 ___builtin_bswap16 :: ___builtin_bswap32 :: ___builtin_bswap ::
 ___builtin_bswap64 :: ___builtin_ais_annot :: ___compcert_i64_umulh ::
 ___compcert_i64_smulh :: ___compcert_i64_sar :: ___compcert_i64_shr ::
 ___compcert_i64_shl :: ___compcert_i64_umod :: ___compcert_i64_smod ::
 ___compcert_i64_udiv :: ___compcert_i64_sdiv :: ___compcert_i64_utof ::
 ___compcert_i64_stof :: ___compcert_i64_utod :: ___compcert_i64_stod ::
 ___compcert_i64_dtou :: ___compcert_i64_dtos :: ___compcert_va_composite ::
 ___compcert_va_float64 :: ___compcert_va_int64 :: ___compcert_va_int32 ::
 nil).

Definition prog : Clight.program := 
  mkprogram composites global_definitions public_idents _main Logic.I.


