/* This file has been generated by the VFPG from tests/regression-tests/for.xml */
/* Version v6.0_unstable-none--dirty */
/* Please DO NOT EDIT */

#ifndef FLIGHT_PLAN_H
#define FLIGHT_PLAN_H

#include "std.h"
#include "generated/modules.h"
#include "modules/core/abi.h"
#include "autopilot.h"


#define FLIGHT_PLAN_NAME "Small1"
#define NAV_DEFAULT_ALT 260 /* nominal altitude of the flight plan */
#define NAV_UTM_EAST0 360285
#define NAV_UTM_NORTH0 4813595
#define NAV_UTM_ZONE0 31
#define NAV_LAT0 434622300 /* 1e7deg */
#define NAV_LON0 12728900 /* 1e7deg */
#define NAV_ALT0 185000 /* mm above msl */
#define NAV_MSL0 51850 /* mm, EGM96 geoid-height (msl) over ellipsoid */
#define QFU 1.0
#define WP_dummy 0
#define WP_HOME 1
#define WP_P1 2
#define WP_P2 3
#define WAYPOINTS_UTM { \
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {100.0, 100.0, 260},\
};
#define WAYPOINTS_ENU { \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
};
#define WAYPOINTS_LLA { \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
};
#define WAYPOINTS_LLA_WGS84 { \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
};
#define WAYPOINTS_GLOBAL { \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
};
#define NB_WAYPOINT 4
#define FP_BLOCKS { \
 "INIT_BLOCK" , \
 "Test Nav" , \
 "Land" , \
 "HOME" , \
}
#define NB_BLOCKS 4
#define GROUND_ALT 185.
#define GROUND_ALT_CM 18500
#define SECURITY_HEIGHT 25.
#define SECURITY_ALT 210.
#define HOME_MODE_HEIGHT 25.
#define MAX_DIST_FROM_HOME 1500.


#ifndef FBW


#endif

#ifdef NAV_C


static inline void auto_nav_init(void) {
}

int _var_i_t_1;

int _var_i_t_1_to;

int _var_j_t_2;

int _var_j_t_2_to;

int _var_i_3;

int _var_i_3_to;

int _var_j_4;

int _var_j_4_to;

unsigned char const nb_blocks = 4;

void on_enter_block(unsigned char block)
{
  switch (block) {
    case 1:
      (enter_0());
      break;
    case 2:
      (enter_3());
      break;
    default:
      break;
    
  }
}

void on_exit_block(unsigned char block)
{
  switch (block) {
    case 1:
      (exit_0());
      break;
    case 2:
      (exit_3());
      break;
    default:
      break;
    
  }
}

_Bool forbidden_deroute(unsigned char from, unsigned char to)
{
  switch (from) {
    default:
      break;
    
  }
  return (_Bool) 0;
}

static inline void auto_nav(void)
{
  unsigned char tmp_nav_block;
  unsigned char tmp_nav_stage;
  _Bool tmp_cond;
  float tmp_RadOfDeg;
  float tmp_AltitudeMode;
  _Bool tmp_NavCond;
  tmp_nav_block = get_nav_block();
  switch (tmp_nav_block) {
    case 0:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        default:
          set_nav_stage(0);
          NextBlock();
          break;
        
      }
      break;
    case 1:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          while_1_0:
          set_nav_stage(0);
          if (!((a==1))) {
            goto endwhile_1_21;
          } else {
            NextStage();
            break;
          }
        case 1:
          set_nav_stage(1);
          test = 1;
          NextStage();
        case 2:
          while_1_2:
          set_nav_stage(2);
          if (!((b==2))) {
            goto endwhile_1_20;
          } else {
            NextStage();
            break;
          }
        case 3:
          set_nav_stage(3);
          test = 2;
          NextStage();
        case 4:
          while_1_4:
          set_nav_stage(4);
          if (!((c==3))) {
            goto endwhile_1_19;
          } else {
            NextStage();
            break;
          }
        case 5:
          set_nav_stage(5);
          _var_i_t_1 = 1;
          NextStage();
        case 6:
          set_nav_stage(6);
          _var_i_t_1_to = 16;
          NextStage();
        case 7:
          while_1_7:
          set_nav_stage(7);
          if (!(_var_i_t_1 <= _var_i_t_1_to)) {
            goto endwhile_1_18;
          } else {
            NextStage();
            break;
          }
        case 8:
          set_nav_stage(8);
          tmp_RadOfDeg = RadOfDeg((90*_var_i_t_1));
          NavHeading(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalAltitudeMode(WaypointAlt(WP_p1), 0);
          if ((stage_time>3)) {
            NextStage();
            break;
          }
          break;
        case 9:
          set_nav_stage(9);
          _var_j_t_2 = 1;
          NextStage();
        case 10:
          set_nav_stage(10);
          _var_j_t_2_to = 16;
          NextStage();
        case 11:
          while_1_11:
          set_nav_stage(11);
          if (!(_var_j_t_2 <= _var_j_t_2_to)) {
            goto endwhile_1_16;
          } else {
            NextStage();
            break;
          }
        case 12:
          while_1_12:
          set_nav_stage(12);
          if (!((c==3))) {
            goto endwhile_1_14;
          } else {
            NextStage();
            break;
          }
        case 13:
          set_nav_stage(13);
          tmp_RadOfDeg = RadOfDeg((90*_var_j_t_2));
          NavHeading(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalAltitudeMode(WaypointAlt(WP_p1), 0);
          if ((stage_time>3)) {
            NextStage();
            break;
          }
          break;
        case 14:
          set_nav_stage(14);
          goto while_1_12;
          endwhile_1_14:
          set_nav_stage(15);
        case 15:
          set_nav_stage(15);
          _var_j_t_2 = _var_j_t_2 + 1;
          NextStage();
        case 16:
          set_nav_stage(16);
          goto while_1_11;
          endwhile_1_16:
          set_nav_stage(17);
        case 17:
          set_nav_stage(17);
          _var_i_t_1 = _var_i_t_1 + 1;
          NextStage();
        case 18:
          set_nav_stage(18);
          goto while_1_7;
          endwhile_1_18:
          set_nav_stage(19);
        case 19:
          set_nav_stage(19);
          goto while_1_4;
          endwhile_1_19:
          set_nav_stage(20);
        case 20:
          set_nav_stage(20);
          goto while_1_2;
          endwhile_1_20:
          set_nav_stage(21);
        case 21:
          set_nav_stage(21);
          goto while_1_0;
          endwhile_1_21:
          set_nav_stage(22);
        default:
          set_nav_stage(22);
          NextBlock();
          break;
        
      }
      break;
    case 2:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          if (!(land())) {
            NextStage();
          } else {
            break;
          }
        case 1:
          set_nav_stage(1);
          Return(1);
          break;
        case 2:
          set_nav_stage(2);
          NextStage();
          nav_goto_block(2);
          break;
        case 3:
          set_nav_stage(3);
          _var_i_3 = 1;
          NextStage();
        case 4:
          set_nav_stage(4);
          _var_i_3_to = 16;
          NextStage();
        case 5:
          while_2_5:
          set_nav_stage(5);
          if (!(_var_i_3 <= _var_i_3_to)) {
            goto endwhile_2_14;
          } else {
            NextStage();
            break;
          }
        case 6:
          set_nav_stage(6);
          tmp_RadOfDeg = RadOfDeg((90*_var_i_3));
          NavHeading(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalAltitudeMode(WaypointAlt(WP_p1), 0);
          if ((stage_time>3)) {
            NextStage();
            break;
          }
          break;
        case 7:
          set_nav_stage(7);
          _var_j_4 = 1;
          NextStage();
        case 8:
          set_nav_stage(8);
          _var_j_4_to = 16;
          NextStage();
        case 9:
          while_2_9:
          set_nav_stage(9);
          if (!(_var_j_4 <= _var_j_4_to)) {
            goto endwhile_2_12;
          } else {
            NextStage();
            break;
          }
        case 10:
          set_nav_stage(10);
          tmp_RadOfDeg = RadOfDeg((90*_var_j_4));
          NavHeading(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalAltitudeMode(WaypointAlt(WP_p1), 0);
          if ((stage_time>3)) {
            NextStage();
            break;
          }
          break;
        case 11:
          set_nav_stage(11);
          _var_j_4 = _var_j_4 + 1;
          NextStage();
        case 12:
          set_nav_stage(12);
          goto while_2_9;
          endwhile_2_12:
          set_nav_stage(13);
        case 13:
          set_nav_stage(13);
          _var_i_3 = _var_i_3 + 1;
          NextStage();
        case 14:
          set_nav_stage(14);
          goto while_2_5;
          endwhile_2_14:
          set_nav_stage(15);
        default:
          set_nav_stage(15);
          NextBlock();
          break;
        
      }
      break;
    default:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          nav_home();
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    
  }
}


#endif // NAV_C

#endif // FLIGHT_PLAN_H
