/* This file has been generated by the VFPG from tests/regression-tests/go.xml */
/* Version v6.0_unstable-none--dirty */
/* Please DO NOT EDIT */

#ifndef FLIGHT_PLAN_H
#define FLIGHT_PLAN_H

#include "std.h"
#include "generated/modules.h"
#include "modules/core/abi.h"
#include "autopilot.h"


#define FLIGHT_PLAN_NAME "Small1"
#define NAV_DEFAULT_ALT 260 /* nominal altitude of the flight plan */
#define NAV_UTM_EAST0 360285
#define NAV_UTM_NORTH0 4813595
#define NAV_UTM_ZONE0 31
#define NAV_LAT0 434622300 /* 1e7deg */
#define NAV_LON0 12728900 /* 1e7deg */
#define NAV_ALT0 185000 /* mm above msl */
#define NAV_MSL0 51850 /* mm, EGM96 geoid-height (msl) over ellipsoid */
#define QFU 1.0
#define WP_dummy 0
#define WP_HOME 1
#define WP_P1 2
#define WP_P2 3
#define WP_P3 4
#define WP_P4 5
#define WP_P5 6
#define WP_P6 7
#define WAYPOINTS_UTM { \
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {100.0, 100.0, 260},\
 {200.0, 100.0, 260},\
 {100.0, 200.0, 260},\
 {200.0, 200.0, 260},\
 {300.0, 100.0, 260},\
};
#define WAYPOINTS_ENU { \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {197.92, 104.15, 75.00}, /* ENU in meters  */ \
 {95.85, 202.07, 75.00}, /* ENU in meters  */ \
 {195.85, 204.15, 74.99}, /* ENU in meters  */ \
 {297.92, 106.22, 74.99}, /* ENU in meters  */ \
};
#define WAYPOINTS_LLA { \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631673, .lon=12753356, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434640487, .lon=12740743, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434640673, .lon=12753100, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631859, .lon=12765712, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
};
#define WAYPOINTS_LLA_WGS84 { \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631673, .lon=12753356, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434640487, .lon=12740743, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434640673, .lon=12753100, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631859, .lon=12765712, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
};
#define WAYPOINTS_GLOBAL { \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
};
#define NB_WAYPOINT 8
#define FP_BLOCKS { \
 "INIT_BLOCK" , \
 "Test Nav" , \
 "HOME" , \
}
#define NB_BLOCKS 3
#define GROUND_ALT 185.
#define GROUND_ALT_CM 18500
#define SECURITY_HEIGHT 25.
#define SECURITY_ALT 210.
#define HOME_MODE_HEIGHT 25.
#define MAX_DIST_FROM_HOME 1500.


#ifndef FBW


#endif

#ifdef NAV_C


static inline void auto_nav_init(void) {
}

unsigned char const nb_blocks = 3;

void on_enter_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

void on_exit_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

_Bool forbidden_deroute(unsigned char from, unsigned char to)
{
  switch (from) {
    default:
      break;
    
  }
  return (_Bool) 0;
}

static inline void auto_nav(void)
{
  unsigned char tmp_nav_block;
  unsigned char tmp_nav_stage;
  _Bool tmp_cond;
  float tmp_RadOfDeg;
  float tmp_AltitudeMode;
  _Bool tmp_NavCond;
  tmp_nav_block = get_nav_block();
  switch (tmp_nav_block) {
    case 0:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        default:
          set_nav_stage(0);
          NextBlock();
          break;
        
      }
      break;
    case 1:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproachingFrom(2, 1, CARROT);
          if (tmp_NavCond) {
            last_wp = 2;
            NextStage();
            break;
          } else {
            NavSegment(1, 2);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(1, 2);
          }
          break;
        case 1:
          set_nav_stage(1);
          tmp_NavCond = NavApproachingFrom(2, 1, -11.300000);
          if (tmp_NavCond) {
            last_wp = 2;
            NextStage();
            break;
          } else {
            NavSegment(1, 2);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(1, 2);
          }
          break;
        case 2:
          set_nav_stage(2);
          tmp_NavCond = NavApproachingFrom(2, 1, 10.100000);
          if (tmp_NavCond) {
            last_wp = 2;
            NextStage();
            break;
          } else {
            NavSegment(1, 2);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(1, 2);
          }
          break;
        case 3:
          set_nav_stage(3);
          tmp_NavCond = NavApproaching(2, 10.100000);
          if (tmp_NavCond) {
            last_wp = 2;
            NextStage();
            break;
          } else {
            NavSegment(last_wp, 2);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(last_wp, 2);
          }
          break;
        case 4:
          set_nav_stage(4);
          (test);
          tmp_NavCond = NavApproaching(3, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(3);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          if (test) {
            (test2);
            NextStage();
            break;
          }
          (test2);
          break;
        case 5:
          set_nav_stage(5);
          (test);
          tmp_NavCond = NavApproaching(4, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(4);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          if (until) {
            (test2);
            NextStage();
            break;
          }
          (test2);
          break;
        case 6:
          set_nav_stage(6);
          (test);
          tmp_NavCond = NavApproaching(5, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(5);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = Height(90);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          (test2);
          break;
        case 7:
          set_nav_stage(7);
          (test);
          tmp_NavCond = NavApproaching(6, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(6);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          (test2);
          break;
        case 8:
          set_nav_stage(8);
          (test);
          tmp_NavCond = NavApproaching(7, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(7);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          (test2);
          break;
        case 9:
          set_nav_stage(9);
          (test);
          tmp_NavCond = NavApproaching(3, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(3, test);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          if (test) {
            (test2);
            NextStage();
            break;
          }
          (test2);
          break;
        case 10:
          set_nav_stage(10);
          (test);
          tmp_NavCond = NavApproaching(4, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(4, test);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          (test2);
          break;
        case 11:
          set_nav_stage(11);
          (test);
          tmp_NavCond = NavApproaching(5, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(5, test);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = Height(90);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          if (until) {
            (test2);
            NextStage();
            break;
          }
          (test2);
          break;
        case 12:
          set_nav_stage(12);
          (test);
          tmp_NavCond = NavApproaching(6, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(6, test);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          (test2);
          break;
        case 13:
          set_nav_stage(13);
          (test);
          tmp_NavCond = TestApproachingFrom(7, 3, CARROT);
          if (tmp_NavCond) {
            (test2);
            last_wp = 7;
            NextStage();
            break;
          } else {
            TestSegment(3, 7, test);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            TestVerticalAutoThrottleMode(tmp_RadOfDeg);
            TestVerticalAltitudeMode(10, 0);
          }
          if (until) {
            (test2);
            NextStage();
            break;
          }
          (test2);
          break;
        case 14:
          set_nav_stage(14);
          tmp_NavCond = NavApproachingFrom(2, 1, 10.100000);
          if (tmp_NavCond) {
            last_wp = 2;
            NextStage();
            break;
          } else {
            NavSegment(1, 2);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavVerticalClimbMode(10);
          }
          break;
        default:
          set_nav_stage(15);
          NextBlock();
          break;
        
      }
      break;
    default:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          nav_home();
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    
  }
}


#endif // NAV_C

#endif // FLIGHT_PLAN_H
