/* This file has been generated by the VFPG from tests/regression-tests/path.xml */
/* Version v6.0_unstable-none--dirty */
/* Please DO NOT EDIT */

#ifndef FLIGHT_PLAN_H
#define FLIGHT_PLAN_H

#include "std.h"
#include "generated/modules.h"
#include "modules/core/abi.h"
#include "autopilot.h"


#define FLIGHT_PLAN_NAME "Small1"
#define NAV_DEFAULT_ALT 260 /* nominal altitude of the flight plan */
#define NAV_UTM_EAST0 360285
#define NAV_UTM_NORTH0 4813595
#define NAV_UTM_ZONE0 31
#define NAV_LAT0 434622300 /* 1e7deg */
#define NAV_LON0 12728900 /* 1e7deg */
#define NAV_ALT0 185000 /* mm above msl */
#define NAV_MSL0 51850 /* mm, EGM96 geoid-height (msl) over ellipsoid */
#define QFU 1.0
#define WP_dummy 0
#define WP_HOME 1
#define WP_P1 2
#define WP_P2 3
#define WP_P3 4
#define WP_P4 5
#define WP_P5 6
#define WP_P6 7
#define WAYPOINTS_UTM { \
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {0.0, 0.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
 {100.0, 100.0, 260},\
};
#define WAYPOINTS_ENU { \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {0.00, -0.00, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
 {97.92, 102.07, 75.00}, /* ENU in meters  */ \
};
#define WAYPOINTS_LLA { \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434622299, .lon=12728900, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
 {.lat=434631486, .lon=12741000, .alt=260000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=51.85m) */ \
};
#define WAYPOINTS_LLA_WGS84 { \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434622299, .lon=12728900, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=434631486, .lon=12741000, .alt=311850}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
};
#define WAYPOINTS_GLOBAL { \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
};
#define NB_WAYPOINT 8
#define FP_BLOCKS { \
 "INIT_BLOCK" , \
 "Test Nav" , \
 "HOME" , \
}
#define NB_BLOCKS 3
#define GROUND_ALT 185.
#define GROUND_ALT_CM 18500
#define SECURITY_HEIGHT 25.
#define SECURITY_ALT 210.
#define HOME_MODE_HEIGHT 25.
#define MAX_DIST_FROM_HOME 1500.


#ifndef FBW


#endif

#ifdef NAV_C


static inline void auto_nav_init(void) {
}

unsigned char const nb_blocks = 3;

void on_enter_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

void on_exit_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

_Bool forbidden_deroute(unsigned char from, unsigned char to)
{
  switch (from) {
    default:
      break;
    
  }
  return (_Bool) 0;
}

static inline void auto_nav(void)
{
  unsigned char tmp_nav_block;
  unsigned char tmp_nav_stage;
  _Bool tmp_cond;
  float tmp_RadOfDeg;
  float tmp_AltitudeMode;
  _Bool tmp_NavCond;
  tmp_nav_block = get_nav_block();
  switch (tmp_nav_block) {
    case 0:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        default:
          set_nav_stage(0);
          NextBlock();
          break;
        
      }
      break;
    case 1:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(2, 3);
          }
          break;
        case 1:
          set_nav_stage(1);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(3, 4);
          }
          break;
        case 2:
          set_nav_stage(2);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(4, 5);
          }
          break;
        case 3:
          set_nav_stage(3);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(5, 6);
          }
          break;
        case 4:
          set_nav_stage(4);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(6, 7);
          }
          break;
        case 5:
          set_nav_stage(5);
          tmp_NavCond = NavApproachingFrom(3, 2, -11.300000);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(2, 3);
          }
          break;
        case 6:
          set_nav_stage(6);
          tmp_NavCond = NavApproachingFrom(4, 3, -11.300000);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(3, 4);
          }
          break;
        case 7:
          set_nav_stage(7);
          tmp_NavCond = NavApproachingFrom(5, 4, -11.300000);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(4, 5);
          }
          break;
        case 8:
          set_nav_stage(8);
          tmp_NavCond = NavApproachingFrom(6, 5, -11.300000);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(5, 6);
          }
          break;
        case 9:
          set_nav_stage(9);
          tmp_NavCond = NavApproachingFrom(7, 6, -11.300000);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(6, 7);
          }
          break;
        case 10:
          set_nav_stage(10);
          tmp_NavCond = NavApproachingFrom(3, 2, 10.100000);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(2, 3);
          }
          break;
        case 11:
          set_nav_stage(11);
          tmp_NavCond = NavApproachingFrom(4, 3, 10.100000);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(3, 4);
          }
          break;
        case 12:
          set_nav_stage(12);
          tmp_NavCond = NavApproachingFrom(5, 4, 10.100000);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(4, 5);
          }
          break;
        case 13:
          set_nav_stage(13);
          tmp_NavCond = NavApproachingFrom(6, 5, 10.100000);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(5, 6);
          }
          break;
        case 14:
          set_nav_stage(14);
          tmp_NavCond = NavApproachingFrom(7, 6, 10.100000);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(6, 7);
          }
          break;
        case 15:
          set_nav_stage(15);
          tmp_NavCond = NavApproachingFrom(3, 2, 10.100000);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(2, 3);
          }
          break;
        case 16:
          set_nav_stage(16);
          tmp_NavCond = NavApproachingFrom(4, 3, 10.100000);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(3, 4);
          }
          break;
        case 17:
          set_nav_stage(17);
          tmp_NavCond = NavApproachingFrom(5, 4, 10.100000);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(4, 5);
          }
          break;
        case 18:
          set_nav_stage(18);
          tmp_NavCond = NavApproachingFrom(6, 5, 10.100000);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(5, 6);
          }
          break;
        case 19:
          set_nav_stage(19);
          tmp_NavCond = NavApproachingFrom(7, 6, 10.100000);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.750000 * 9600);
            NavGlide(6, 7);
          }
          break;
        case 20:
          set_nav_stage(20);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 21:
          set_nav_stage(21);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 22:
          set_nav_stage(22);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 23:
          set_nav_stage(23);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 24:
          set_nav_stage(24);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 25:
          set_nav_stage(25);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalClimbMode(10.500000);
          }
          break;
        case 26:
          set_nav_stage(26);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalClimbMode(10.500000);
          }
          break;
        case 27:
          set_nav_stage(27);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalClimbMode(10.500000);
          }
          break;
        case 28:
          set_nav_stage(28);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalClimbMode(10.500000);
          }
          break;
        case 29:
          set_nav_stage(29);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalClimbMode(10.500000);
          }
          break;
        case 30:
          set_nav_stage(30);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 31:
          set_nav_stage(31);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 32:
          set_nav_stage(32);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 33:
          set_nav_stage(33);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 34:
          set_nav_stage(34);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 35:
          set_nav_stage(35);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(3);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 36:
          set_nav_stage(36);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(4);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 37:
          set_nav_stage(37);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(5);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 38:
          set_nav_stage(38);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(6);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 39:
          set_nav_stage(39);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(7);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 40:
          set_nav_stage(40);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 41:
          set_nav_stage(41);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 42:
          set_nav_stage(42);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 43:
          set_nav_stage(43);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 44:
          set_nav_stage(44);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 45:
          set_nav_stage(45);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 46:
          set_nav_stage(46);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 47:
          set_nav_stage(47);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 48:
          set_nav_stage(48);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 49:
          set_nav_stage(49);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 50:
          set_nav_stage(50);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 51:
          set_nav_stage(51);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 52:
          set_nav_stage(52);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 53:
          set_nav_stage(53);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 54:
          set_nav_stage(54);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalThrottleMode(0.100000 * 9600);
          }
          break;
        case 55:
          set_nav_stage(55);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 56:
          set_nav_stage(56);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 57:
          set_nav_stage(57);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 58:
          set_nav_stage(58);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 59:
          set_nav_stage(59);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(110, 0);
          }
          break;
        case 60:
          set_nav_stage(60);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(3);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 61:
          set_nav_stage(61);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(4);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 62:
          set_nav_stage(62);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(5);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 63:
          set_nav_stage(63);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(6);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 64:
          set_nav_stage(64);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            tmp_AltitudeMode = WaypointAlt(7);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 65:
          set_nav_stage(65);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 66:
          set_nav_stage(66);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 67:
          set_nav_stage(67);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 68:
          set_nav_stage(68);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 69:
          set_nav_stage(69);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            NavVerticalAutoPitchMode(0.100000 * 9600);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 70:
          set_nav_stage(70);
          tmp_NavCond = NavApproachingFrom(3, 2, CARROT);
          if (tmp_NavCond) {
            last_wp = 3;
            NextStage();
            break;
          } else {
            NavSegment(2, 3);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 71:
          set_nav_stage(71);
          tmp_NavCond = NavApproachingFrom(4, 3, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(3, 4);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 72:
          set_nav_stage(72);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 73:
          set_nav_stage(73);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        case 74:
          set_nav_stage(74);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            tmp_RadOfDeg = RadOfDeg(10.500000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            NavVerticalAltitudeMode(10, 0);
          }
          break;
        default:
          set_nav_stage(75);
          NextBlock();
          break;
        
      }
      break;
    default:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          nav_home();
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    
  }
}


#endif // NAV_C

#endif // FLIGHT_PLAN_H
